KUBE_CONFIG = ~/.kube/k8s-1-20-7-do-0-fra1-1624110694779-kubeconfig.yaml
TAG = v1

### Docker
build-image:
	docker build --tag zero-downtime-deployment:$(TAG) .

tag-image:
	docker tag zero-downtime-deployment:$(TAG) foofaev/zero-downtime-deployment:$(TAG)

push-image:
	docker push foofaev/zero-downtime-deployment:$(TAG)

### k8s
kompose:
	kompose convert

get-pods:
	kubectl --kubeconfig $(KUBE_CONFIG) get pods

get-pods-wide:
	kubectl --kubeconfig $(KUBE_CONFIG) get pods -o wide

get-deployments:
	kubectl --kubeconfig $(KUBE_CONFIG) get deployments

describe-deployments:
	kubectl --kubeconfig $(KUBE_CONFIG) describe deployments

describe-pods:
	kubectl --kubeconfig $(KUBE_CONFIG) describe pods

get-services:
	kubectl --kubeconfig $(KUBE_CONFIG) get services

apply-changes:
	kubectl --kubeconfig $(KUBE_CONFIG) apply -f ./k8s/app-deployment.yaml,./k8s/app-service.yaml,./k8s/env-configmap.yaml,./k8s/secret.yaml

view-last-applied:
	kubectl --kubeconfig $(KUBE_CONFIG) apply -f ./k8s/app-deployment.yaml,./k8s/app-service.yaml,./k8s/env-configmap.yaml,./k8s/secret.yaml view-last-applied

get-secrets:
	kubectl --kubeconfig $(KUBE_CONFIG) get secrets

set-image:
	kubectl --kubeconfig $(KUBE_CONFIG) set image deployments/app app=foofaev/zero-downtime-deployment:$(TAG)

### Ansible
install-ansible-dependecies:
	ansible-galaxy install -r ansible/requirements.yml

ansible-ping:
	ansible all -i ansible/inventory.ini -m ping -u root

ansible-deploy:
	ansible-playbook -i ansible/inventory.ini ansible/playbook.yml -u root --ask-vault-pass

vault-encrypt:
	ansible-vault encrypt ansible/group_vars/vault.yml

vault-view:
	ansible-vault view ansible/group_vars/vault.yml

vault-edit:
	ansible-vault edit ansible/group_vars/vault.yml
